////////////////////////////////////////////////////////////////////////////////////////////////
//MLFT}_[pVF[_
//	
//	T.Ogurãt@[VF[_x[XɂĂ܂
//
//	t͔CeBO𗘗pĂ̌yAet
//	ZtVhẼ\tgł
////////////////////////////////////////////////////////////////////////////////////////////////
// уVF[_[p@Rg[p[^
const float FurSupecularPower = 2;      // т͈̌
const float FurFlowScale = float2(500,1); // т̗
const float3 FurColor = float3(1.0, 1.0, 1.0); // т̐F

int FurShellCount = 5; // FurShell̖
const float FurLength = 1/50.0;  // FurShell̕

bool g_HalfLambert = 0; //n[to[gtO


// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldMatrix              : WORLD;
float4x4 ViewMatrix               : VIEW;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

// }eAF
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3   MaterialToon      : TOONCOLOR;
// CgF
float3   LightDiffuse      : DIFFUSE   < string Object = "Light"; >;
float3   LightAmbient      : AMBIENT   < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float4 DiffuseColor  = MaterialDiffuse  * float4(LightDiffuse, 1.0f);
static float3 AmbientColor  = saturate(MaterialAmbient  * LightAmbient + MaterialEmmisive);
static float3 SpecularColor = MaterialSpecular * LightSpecular;

bool     parthf;   // p[XyNeButO
bool     transp;   // tO
bool	 spadd;    // XtBA}bvZtO
#define SKII1    1500
#define SKII2    8000
#define Toon     3

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};
// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);
////////////////////////////////////////////////////////////////////////////////
//fBt[YF{ArGgF vZ
float4 CalcColor(float4 Dif_Col, float3 Amb_Col, float Normal_dot, bool useToon)
{
	float4 Color;
	Color.rgb = Amb_Col;

	if ( !useToon ) {
		//o[giANZTpHj
		Color.rgb += max(0, Normal_dot) * Dif_Col.rgb;
	}
	if(g_HalfLambert){
		//n[to[g
		float HarfLam = pow(max(0, Normal_dot)*0.5f+0.5f, 2);
		//float HarfLam = max(0, Normal_dot);
		Color.rgb *= lerp(MaterialToon,float3(1.0f, 1.0f, 1.0f), HarfLam);

		//Color.rgb =  MaterialAmbient*float3(0.8f, 0.8f, 0.8f);// MaterialEmmisive * LightAmbient;
		//Color.rgb =   MaterialAmbient;// MaterialEmmisive * LightAmbient;
		//Color.rgb += MaterialEmmisive * LightAmbient * pow(max(0, Normal_dot)*0.5f+0.5f, 2);
		//Color.rgb += MaterialEmmisive * LightAmbient * max(0, Normal_dot);
	}
	Color.a = Dif_Col.a;//x
	Color = saturate( Color );

	return Color;
}


////////////////////////////////////////////////////////////////////////////////
//AetpCeBO
float3 CalcHemisphere(float3 Color, float Normal_dot)
{
	float3 Hemi;
	float3 Shadow_Col = pow(MaterialToon, 3);//eF𐶐
	float LerpFactor = saturate(Normal_dot + 1.0f);//Ő`Ԃ̈q߂

	Hemi = lerp(Shadow_Col, float3(1.0f, 1.0f, 1.0f), LerpFactor);

	return Hemi;
}
////////////////////////////////////////////////////////////////////////////////
//XyLvZ
float3 CalcSpecular(float3 inNomal, float3 inEye, float3 inLight, float3 inColor)
{
	float3 Specular;
	float3 L = inLight;
	float3 N = normalize(inNomal);
	float3 V = normalize(inEye);
	float3 H = normalize( V + L );
		//tHʔ
		Specular = pow( max(0,dot(H, N)), SpecularPower ) * SpecularColor;


	return Specular;
}



///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEONj

// VhEobt@̃TvB"register(s0)"Ȃ̂MMDs0gĂ邩
sampler DefSampler : register(s0);


//\tgVhE
float SoftShadow(float2 inUV, float inZCalcTex, int inSkll)
{
	float comp = 0.0f;
	//VhE}bṽeNX`TCY1sNZo//////////
	//i킩Ȃ̂Ō\Kj/////////////////////////////////////////
	float U = 1.0f / SKII1;//(*2.0f)
	float V = 1.0f / SKII1;//(*2.0f)
	/////////////////////////////////////////////////////////////////////
	float2 uv;
	uv = inUV + float2(0.0f, -V);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);
	uv = inUV + float2(U, -V);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);
	uv = inUV + float2(-U, 0.0f);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);
	uv = inUV + float2(U, 0.0f);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);
	uv = inUV + float2(-U, -V);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);
	uv = inUV + float2(0.0f, V);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);
	uv = inUV + float2(U, V);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);
	uv = inUV + float2(-U, V);
	comp += 1-saturate(max(inZCalcTex-tex2D(DefSampler,uv).r , 0.0f)*inSkll-0.3f);

	comp /= 8.0f;
	return comp;
}


struct BufferShadow_OUTPUT {
    float4 Pos      : POSITION;     // ˉeϊW
    float4 ZCalcTex : TEXCOORD0;    // Zl
    float2 Tex      : TEXCOORD1;    // eNX`
    float3 Normal   : TEXCOORD2;    // @
    float3 Eye      : TEXCOORD3;    // JƂ̑Έʒu
    float2 SpTex    : TEXCOORD4;	 // XtBA}bveNX`W
    float4 Color    : COLOR0;       // fBt[YF

	float2 ToonTex	: TEXCOORD5;	//gD[peNX` 
};

// _VF[_
BufferShadow_OUTPUT BufferShadow_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
     BufferShadow_OUTPUT Out = (BufferShadow_OUTPUT)0;

    // J_̃[hr[ˉeϊ
    Out.Pos = mul( Pos, WorldViewProjMatrix );

	// J̈ʒu
	Out.Eye = CameraPosition - mul( Pos, WorldMatrix ).xyz;
    // _@
    Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
	// Cg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex = mul( Pos, LightWorldViewProjMatrix );
    

	//Cg̈ʒuςvZ
	Out.ToonTex = float2(0.0f, dot( Out.Normal, -LightDirection ));

	// fBt[YF{ArGgF vZ
	Out.Color = CalcColor(DiffuseColor, AmbientColor, Out.ToonTex.y, useToon);
	//AeCeBǑʂ
	Out.Color.rgb *= CalcHemisphere(Out.Color.rgb, Out.ToonTex.y);
    
    // eNX`W
    Out.Tex = Tex;

    if ( useSphereMap ) {
        // XtBA}bveNX`W
        float2 NormalWV = mul( Out.Normal, (float3x3)ViewMatrix );
        Out.SpTex.x = NormalWV.x * 0.5f + 0.5f;
        Out.SpTex.y = NormalWV.y * -0.5f + 0.5f;
    }
    
    return Out;
}


// sNZVF[_
float4 BufferShadow_PS(BufferShadow_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR
{

    float4 Color = IN.Color;
    float4 ShadowColor = float4(AmbientColor, Color.a);  // e̐F
    if ( useTexture ) {
        // eNX`Kp
        //float4 TexColor = tex2D( ObjTexSampler, IN.Tex );
        //Color *= TexColor;
        //ShadowColor *= TexColor;
        Color *= tex2D( ObjTexSampler, IN.Tex );
    }
    if ( useSphereMap ) {
        // XtBA}bvKp
        float4 TexColor = tex2D(ObjSphareSampler,IN.SpTex);
        if(spadd) {
            Color += TexColor;
            ShadowColor += TexColor;
        } else {
            Color *= TexColor;
            ShadowColor *= TexColor;
        }
    }
	// XyLKp
	//5̐ĺ@0=tHʔ
	float3 SpeColor = CalcSpecular(IN.Normal, IN.Eye, -LightDirection, IN.Color);
	Color.rbg += SpeColor;


    // eNX`Wɕϊ
    IN.ZCalcTex /= IN.ZCalcTex.w;
    float2 TransTexCoord;
    TransTexCoord.x = (1.0f + IN.ZCalcTex.x)*0.5f;
    TransTexCoord.y = (1.0f - IN.ZCalcTex.y)*0.5f;
    

    if( any( saturate(TransTexCoord) != TransTexCoord ) ) {
        // VhEobt@O
        return Color;
    } else {
        float comp = 0.0f;
        if(parthf) {
		// ZtVhE mode2
		comp = SoftShadow(TransTexCoord, IN.ZCalcTex.z, SKII2);
            //comp=1-saturate(max(IN.ZCalcTex.z-tex2D(DefSampler,TransTexCoord).r , 0.0f)*SKII2*TransTexCoord.y-0.3f);
        } else {	
		// ZtVhE mode1
		comp = SoftShadow(TransTexCoord, IN.ZCalcTex.z, SKII1);
		//comp=1-saturate(max(IN.ZCalcTex.z-tex2D(DefSampler,uv).r , 0.0f)*SKII1-0.3f);
        }
        if ( useToon ) {
            // gD[Kp
		if(!g_HalfLambert)
			comp = min(saturate(IN.ToonTex.y * 16 + 0.5),comp);
	}
        float4 ans =lerp(float4(MaterialToon, 1.0f), float4(1.0f, 1.0f, 1.0f, 1.0f), comp);
        if( transp ) ans.a *= 0.5f;
	Color *= ans;

        return Color;
    }
}


//-----------------------------------------------------------------------------------------------

int nFur;               // ݕ`撆FurShellԍ

texture2D fur_tex <
   string ResourceName = "a_tex_fur2.dds";        int Miplevels = 1;
>;
sampler FurSampler = sampler_state {
   texture = <fur_tex>;
};

// _VF[_ i{`ĈߕKvȌvZĂj
BufferShadow_OUTPUT Fur_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0,  uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
    BufferShadow_OUTPUT Out = (BufferShadow_OUTPUT)0;

    // J_̃[hr[ˉeϊ
    Out.Pos = mul( Pos+float4(Normal.xyz*FurLength,0)*nFur, WorldViewProjMatrix );
    
    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( Pos, WorldMatrix );
    // _@
    Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
	// Cg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex = mul( Pos, LightWorldViewProjMatrix );
    
    // fBt[YF{ArGgF vZ
    Out.Color.rgb = AmbientColor;
    if ( !useToon ) {
        Out.Color.rgb += max(0,dot( Out.Normal, -LightDirection )) * DiffuseColor.rgb;
    }
    Out.Color.a = DiffuseColor.a;
    Out.Color = saturate( Out.Color );
    
    // eNX`W
    Out.Tex = Tex;
    
    if ( useSphereMap ) {
        // XtBA}bveNX`W
        float2 NormalWV = mul( Out.Normal, (float3x3)ViewMatrix );
        Out.SpTex.x = NormalWV.x * 0.5f + 0.5f;
        Out.SpTex.y = NormalWV.y * -0.5f + 0.5f;
    }
    
    return Out;
}


////////////////////////////////////////////////////////////////////
//ڋԂ߂֐
float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View); 
  float3 dp2 = ddy(View);

  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = normalize(mul(float2(duv1.x, duv2.x), inverseM));
  float3 Binormal=cross(Normal,Tangent);
  Tangent = cross(Binormal,Normal);

  return float3x3(Tangent,-Binormal,Normal);//float3x3(-Tangent,-Binormal,Normal);//{͂
}


float ftime : TIME <bool SyncInEditMode=false;>;

float4 Fur_PS(BufferShadow_OUTPUT IN, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon) : COLOR
{
	///////////////////////////////////////////////////////////////////////
	//_xNgƃCgxNgڋԂɕϊ
	float3x3 tangentFrame = compute_tangent_frame(IN.Normal, IN.Eye, IN.Tex);
	float3 Eye = mul(tangentFrame, IN.Eye);
	float3 LightDir = normalize(mul(tangentFrame, LightDirection));
	//@
	float3 NomalMap = tex2D(FurSampler, IN.Tex);
	NomalMap = normalize(2*NomalMap - 1.0f);

    // XyLFvZ
    float3 HalfVector = normalize(Eye + -LightDir); // т̌BD݂̖肩
 //float3 HalfVector = normalize(Eye);
    float3 Specular = 1.0f - pow( max(0,dot( HalfVector, NomalMap )), FurSupecularPower ) * float3(0.5f, 0.5f ,0.5f);


    //float4 Color = IN.Color;
	float dotNormal = dot( NomalMap, -LightDir );
	float4 Color = CalcColor(DiffuseColor, AmbientColor, dotNormal, useToon);
	Color.rgb *= CalcHemisphere(Color.rgb, dotNormal);

    //float4 ShadowColor = float4(AmbientColor, Color.a);  // e̐F
    float4 ShadowColor = float4(0.1f, 0.1f, 0.8f, Color.a);  // e̐F
    if ( useTexture ) {
        // eNX`Kp
        float4 TexColor =  tex2D( ObjTexSampler, IN.Tex ) + float4(Specular.xyz,0);
        Color *= TexColor;
        ShadowColor *= TexColor;
    }
    
    // XtBA}bvΉ
    // XyLKp
    // WPbg̐FÂ߁AŒF悤Bx[X̐FgĂ

	float2 furDire = float2(1.0, 0.0);
	Color.rgb = IN.Color * Specular.r;
	
	// ˂˂Ȏ(GPUɒ)
	//float2 furDire = float2(sin(ftime+IN.Tex.x*20),cos(ftime+IN.Tex.y*40));
    //Color.rgb = float3(1.0-(furDire.x+1.0)/2.0,(furDire.x+1.0)/2.0,(furDire.y+1.0)/2.0) * Specular.r;
     
     // уeNX`ѕ̃At@BѐɍsقǔȂ
    
	Color.w = tex2D( FurSampler, IN.Tex- furDire / FurFlowScale * nFur).w * (1.0-nFur/(FurShellCount-1.0)); 
	
	return Color; // Furɑ΂ZtVhE͂܂ǂȂ̂ŁAőł؂̂
    
    // eNX`Wɕϊ
    IN.ZCalcTex /= IN.ZCalcTex.w;
    float2 TransTexCoord;
    TransTexCoord.x = (1.0f + IN.ZCalcTex.x)*0.5f;
    TransTexCoord.y = (1.0f - IN.ZCalcTex.y)*0.5f;
	
    if( any( saturate(TransTexCoord) != TransTexCoord ) ) {// VhEobt@O  
        return Color;
    } else {
        float comp;
        if(parthf) {
            // ZtVhE mode2
            comp=1-saturate(max(IN.ZCalcTex.z-tex2D(DefSampler,TransTexCoord).r , 0.0f)*SKII2*TransTexCoord.y-0.3f);
        } else {
            // ZtVhE mode1
            comp=1-saturate(max(IN.ZCalcTex.z-tex2D(DefSampler,TransTexCoord).r , 0.0f)*SKII1-0.3f);
        }
        return Color * ( 0.7 +  comp *0.3) ; // ȅ͏Â
    }
}

// 11ԂWPbg̃f
technique MainTecBS5  <
string MMDPass = "object_ss"; string subSet="0";  bool UseTexture = false; bool UseSphereMap = false; bool UseToon = true; 

       string Script =
	       "Pass = DrawObject;"
           "LoopByCount=FurShellCount;"
           "LoopGetIndex=nFur;"
           "Pass=Fur;"
           "LoopEnd=;";

> {
    // ñWPbgfBtHgVF[_[ŕ`悷
    pass DrawObject {
        VertexShader = compile vs_3_0 BufferShadow_VS(false, false, true);
        PixelShader  = compile ps_3_0 BufferShadow_PS(false, false, true);
    }
    // уVF[_[
    pass Fur {
	    AlphaBlendEnable = TRUE;
		ZEnable      = TRUE;
		ZWriteEnable = false; // ѕDepthobt@XVȂ
		CULLMODE = CCW;

        VertexShader = compile vs_3_0 Fur_VS(true, false, true);
        PixelShader  = compile ps_3_0 Fur_PS(true, false, true);
    }
}


technique MainTecBS4  < string MMDPass = "object_ss"; bool UseTexture = false; bool UseSphereMap = false; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 BufferShadow_VS(false, false, true);
        PixelShader  = compile ps_3_0 BufferShadow_PS(false, false, true);
    }
}

technique MainTecBS5  < string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = false; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 BufferShadow_VS(true, false, true);
        PixelShader  = compile ps_3_0 BufferShadow_PS(true, false, true);
    }
}

technique MainTecBS6  < string MMDPass = "object_ss"; bool UseTexture = false; bool UseSphereMap = true; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 BufferShadow_VS(false, true, true);
        PixelShader  = compile ps_3_0 BufferShadow_PS(false, true, true);
    }
}

technique MainTecBS7  < string MMDPass = "object_ss"; bool UseTexture = true; bool UseSphereMap = true; bool UseToon = true; > {
    pass DrawObject {
        VertexShader = compile vs_3_0 BufferShadow_VS(true, true, true);
        PixelShader  = compile ps_3_0 BufferShadow_PS(true, true, true);
    }
}